<?php

/**
 * cgmv_inf_cuenta_pagar actions.
 *
 * @package    radicacionVirtualCuentas
 * @subpackage cgmv_inf_cuenta_pagar
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class cgmv_inf_cuenta_pagarActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = ' Order by fecha_radicado, radicado';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];

            /*
             * Variables opcionales
             */
            //id_contratista
            if (isset($request['id_contratista'])) {
                $whereIdContratista = " AND tab0.id_contratista = " . $request['id_contratista'];
            } else {
                $whereIdContratista = ' ';
            }
            //id_contrato
            if (isset($request['id_contrato'])) {
                $whereIdContrato = " AND tab0.id_contrato = " . $request['id_contrato'];
            } else {
                $whereIdContrato = ' ';
            }
            //id_numero_pago
            if (isset($request['id_numero_pago'])) {
                $whereIdNumeroPago = " AND tab0.id_numero_pago = " . $request['id_numero_pago'];
            } else {
                $whereIdNumeroPago = ' ';
            }
            //Recurso: 0-ANM 1-SGR
            if(isset($request['recurso'])){
                if($request['recurso'] == 1){
                    $whereTipoRecurso = " AND tab0.tipo_recurso = 1 ";
                }elseif($request['recurso'] == 0 && $request['recurso'] != 'false'){
                    $whereTipoRecurso = " AND tab0.tipo_recurso = 0 ";
                }else{
                    $whereTipoRecurso = " ";
                }               
            }else{
                $whereTipoRecurso = "";
            }

            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /**
             * Consulta de pagos por fecha y estado aprobado
             * Recurso: 0-ANM 1-SGR
             * Cambiar  "Fecha Inicio de Pago"-"Fecha Aprobación Financiera ...:    - 20180822
             */
            $consulta_sql = <<<EOD
select
case when tipo_recurso = 0 then '21-12-00' else '01-211200' end as PCIConexion,
case when tipo_recurso = 0 then nvl(tab0.rp_anm,tab0.rp_sgr) else nvl(tab0.rp_sgr,tab0.rp_anm) end as ConsecutivoCompromiso,
case when tipo_recurso = 0 
      then case when tab0.declarante_renta = 1 then '31' else '64' end 
      else case when tab0.declarante_renta = 1 then '053' else '054' end end as TipoCuentaPorPagar,
rownum as Consecutivo,
tab0.*

from(

    select 
    
    case when INSTR(cont.num_contrato,'SGR') = 1 then 1 else 0 end as tipo_recurso,
    cont.rp_anm,
    cont.rp_sgr,
    contra.declarante_renta,
    contra.num_cuenta,
    tc.descripcion as tipo_cuenta,
    
    to_char(sysdate,'yyyy-mm-dd') as FechaRegistro,
    '03' as TipoDocumentoIdentidad,
    contra.num_doc as NumeroDocumentoTercero,
    forpag.valor_mensual as ValorPesos,
    0 as TasaCambio,
    forpag.valor_iva as ValorIVA,
    'RADICADO No '|| forpag.numero_radicado || ' - ' || num.descripcion || ' PAGO CONTRATO ' || cont.num_contrato as TextoCreacion,
    11 as TipoDocSoporte,
    cont.num_contrato as NumeroDocSoporte,
    to_char(sysdate,'yyyy-mm-dd') as FechaSolicitud,
    11 as Expedidor,
    cont.razon_soc_sup as NombreFuncionario,
    'SUPERVISOR' as CargoFuncionario,
    
    forpag.*
    
    from rvc_formato_pago_v forpag
    
    left join rvc_contrato_v cont
    on forpag.id_contrato = cont.id_contrato
    
    left join rvc_contratista_v contra
    on forpag.id_contratista = contra.id_contratista
    
    left join ts_tc tc
    on tc.id = contra.tipo_cuenta
    
    left join rvc_numero_pago num
    on num.id_numero_pago = forpag.id_numero_pago
    
    where
    forpag.estado = 1
    and forpag.aprobado = 1
    
    order by
    forpag.fecha_radicado,
    forpag.radicado
    
)tab0  
    
where
(  
    trunc(tab0.FECHA_APROBADO) between to_date('$fecha_ini','yyyy-mm-dd') and to_date('$fecha_fin','yyyy-mm-dd')
    /*
    tab0.fecha_ini_pago between to_date('$fecha_ini','yyyy-mm-dd') and to_date('$fecha_fin','yyyy-mm-dd')
    or
    tab0.fecha_fin_pago between to_date('$fecha_ini','yyyy-mm-dd') and to_date('$fecha_fin','yyyy-mm-dd')
    */
)
$whereIdContratista
$whereIdContrato    
$whereIdNumeroPago
$whereTipoRecurso    
EOD;

            /*
             * Sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (
                    
    $consulta_sql    
                    
)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

    $consulta_sql

    $sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[cgmv_inf_cuenta_pagar] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
